#
# Checkpoint
#

require_relative 'station'
require_relative 'prognosis'

module Transport
  class Checkpoint
    attr_reader :station, :arrival, :departure, :platform, :prognosis
    
    def initialize(checkpoint)
      return unless checkpoint
      
      @station = Station.new checkpoint['station']
      @arrival = DateTime.parse(checkpoint['arrival']) if checkpoint['arrival']
      @departure = DateTime.parse(checkpoint['departure']) if checkpoint['departure']
      @delay = checkpoint['delay'].to_i if checkpoint['delay']
      @platform = checkpoint['platform']
      @prognosis = Prognosis.new checkpoint['prognosis']
    end
  end
end
