#
# Locations
#

require 'httparty'
require_relative 'transport_factory'

module Transport
  class Timetable
    include HTTParty
    
    attr_accessor :parse
    
    base_uri 'transport.opendata.ch'
    
    # default_params :output => 'json'
  
    def initialize
      @version = 'v1'
      @parse = true
      @options = { query: {  } }
    end
  
    def search_station station_partial
      request 'locations', query: { query: station_partial }
    end
    
    def search_connection from, to
      request 'connections', query: { from: from, to: to}
    end
    
    def board_for station, limit=15
      request 'stationboard', query: { station: station, limit: limit}
    end

    
    private
    def restful_url page
      "/#{@version}/#{page}"
    end 
    
    def request resource, options
      parse_filter(self.class.get(restful_url(resource), @options.merge(options)), resource)
    end

    def parse_filter unparsed_result, resource
      if @parse
        TransportFactory::create(unparsed_result, resource)
      else
        unparsed_result
      end
    end

 end
end
