#
# Transport Factory
#

require 'httparty'
require_relative 'station'
require_relative 'connection'
require_relative 'journey'
require_relative 'error'

module Transport
  class TransportFactory
    def self.create(json, resource)
      if json['errors']
        return Error.new json
      else
        case resource
          when 'locations'
            return json['stations'].map do |station|
              Station.new station
            end
          when 'connections'
            return json[resource].map do |connection|
              Connection.new connection
            end
          when 'stationboard'
            return json[resource].map do |journey|
              Journey.new journey
            end
          else
            raise ArgumentError.new('Unknown Resource: ', resource)
        end
      end
    end
  end
end
